diff --git a/gcc/config/rs6000/rs6000.c b/gcc/config/rs6000/rs6000.c
index 036a2af..14f8c18 100644
--- a/gcc/config/rs6000/rs6000.c
+++ b/gcc/config/rs6000/rs6000.c
@@ -3389,10 +3389,10 @@ rs6000_option_override_internal (bool global_init_p)
      swapping the words.  */
   if (TARGET_QUAD_MEMORY && !WORDS_BIG_ENDIAN)
     {
-      if ((rs6000_isa_flags_explicit & OPTION_MASK_QUAD_MEMORY) != 0)
+      if ((GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_QUAD_MEMORY) != 0)
 	warning (0, N_("-mquad-memory is not available in little endian mode"));
 
-      rs6000_isa_flags &= ~OPTION_MASK_QUAD_MEMORY;
+      GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_QUAD_MEMORY;
     }
 
   /* Assume if the user asked for normal quad memory instructions, they want
@@ -3400,40 +3400,40 @@ rs6000_option_override_internal (bool global_init_p)
      word atomic instructions.  */
   if (TARGET_QUAD_MEMORY
       && !TARGET_QUAD_MEMORY_ATOMIC
-      && ((rs6000_isa_flags_explicit & OPTION_MASK_QUAD_MEMORY_ATOMIC) == 0))
-    rs6000_isa_flags |= OPTION_MASK_QUAD_MEMORY_ATOMIC;
+      && ((GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_QUAD_MEMORY_ATOMIC) == 0))
+    GCC_OPTION (rs6000_isa_flags) |= OPTION_MASK_QUAD_MEMORY_ATOMIC;
 
   /* Enable power8 fusion if we are tuning for power8, even if we aren't
      generating power8 instructions.  */
-  if (!(rs6000_isa_flags_explicit & OPTION_MASK_P8_FUSION))
-    rs6000_isa_flags |= (processor_target_table[tune_index].target_enable
+  if (!(GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_P8_FUSION))
+    GCC_OPTION (rs6000_isa_flags) |= (processor_target_table[tune_index].target_enable
 			 & OPTION_MASK_P8_FUSION);
 
   /* Power8 does not fuse sign extended loads with the addis.  If we are
      optimizing at high levels for speed, convert a sign extended load into a
      zero extending load, and an explicit sign extension.  */
   if (TARGET_P8_FUSION
-      && !(rs6000_isa_flags_explicit & OPTION_MASK_P8_FUSION_SIGN)
+      && !(GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_P8_FUSION_SIGN)
       && optimize_function_for_speed_p (cfun)
-      && optimize >= 3)
-    rs6000_isa_flags |= OPTION_MASK_P8_FUSION_SIGN;
+      && GCC_OPTION (optimize) >= 3)
+    GCC_OPTION (rs6000_isa_flags) |= OPTION_MASK_P8_FUSION_SIGN;
 
   if (TARGET_DEBUG_REG || TARGET_DEBUG_TARGET)
-    rs6000_print_isa_options (stderr, 0, "after defaults", rs6000_isa_flags);
+    rs6000_print_isa_options (stderr, 0, "after defaults", GCC_OPTION (rs6000_isa_flags));
 
   /* E500mc does "better" if we inline more aggressively.  Respect the
      user's opinion, though.  */
-  if (rs6000_block_move_inline_limit == 0
-      && (rs6000_cpu == PROCESSOR_PPCE500MC
-	  || rs6000_cpu == PROCESSOR_PPCE500MC64
-	  || rs6000_cpu == PROCESSOR_PPCE5500
-	  || rs6000_cpu == PROCESSOR_PPCE6500))
-    rs6000_block_move_inline_limit = 128;
+  if (GCC_OPTION (rs6000_block_move_inline_limit) == 0
+      && (GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE500MC
+	  || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE500MC64
+	  || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE5500
+	  || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE6500))
+    GCC_OPTION (rs6000_block_move_inline_limit) = 128;
 
   /* store_one_arg depends on expand_block_move to handle at least the
      size of reg_parm_stack_space.  */
-  if (rs6000_block_move_inline_limit < (TARGET_POWERPC64 ? 64 : 32))
-    rs6000_block_move_inline_limit = (TARGET_POWERPC64 ? 64 : 32);
+  if (GCC_OPTION (rs6000_block_move_inline_limit) < (TARGET_POWERPC64 ? 64 : 32))
+    GCC_OPTION (rs6000_block_move_inline_limit) = (TARGET_POWERPC64 ? 64 : 32);
 
   if (global_init_p)
     {
@@ -3447,7 +3447,7 @@ rs6000_option_override_internal (bool global_init_p)
 	  targetm.sched.adjust_cost = rs6000_debug_adjust_cost;
 	}
 
-      if (TARGET_DEBUG_ADDR)
+      if (GCC_OPTION (TARGET_DEBUG_ADDR))
 	{
 	  targetm.legitimate_address_p = rs6000_debug_legitimate_address_p;
 	  targetm.legitimize_address = rs6000_debug_legitimize_address;
@@ -3465,14 +3465,14 @@ rs6000_option_override_internal (bool global_init_p)
 	    = rs6000_debug_mode_dependent_address;
 	}
 
-      if (rs6000_veclibabi_name)
+      if (GCC_OPTION (rs6000_veclibabi_name))
 	{
-	  if (strcmp (rs6000_veclibabi_name, "mass") == 0)
+	  if (strcmp (GCC_OPTION (rs6000_veclibabi_name), "mass") == 0)
 	    rs6000_veclib_handler = rs6000_builtin_vectorized_libmass;
 	  else
 	    {
 	      error ("unknown vectorization library ABI type (%s) for "
-		     "-mveclibabi= switch", rs6000_veclibabi_name);
+		     "-mveclibabi= switch", GCC_OPTION (rs6000_veclibabi_name));
 	      ret = false;
 	    }
 	}
@@ -3485,12 +3485,12 @@ rs6000_option_override_internal (bool global_init_p)
 	      != RS6000_DEFAULT_LONG_DOUBLE_SIZE))
 	error ("target attribute or pragma changes long double size");
       else
-	rs6000_long_double_type_size = RS6000_DEFAULT_LONG_DOUBLE_SIZE;
+	GCC_OPTION (rs6000_long_double_type_size) = RS6000_DEFAULT_LONG_DOUBLE_SIZE;
     }
 
 #if !defined (POWERPC_LINUX) && !defined (POWERPC_FREEBSD)
   if (!global_options_set.x_rs6000_ieeequad)
-    rs6000_ieeequad = 1;
+    GCC_OPTION (rs6000_ieeequad) = 1;
 #endif
 
   /* Disable VSX and Altivec silently if the user switched cpus to power7 in a
@@ -3498,8 +3498,8 @@ rs6000_option_override_internal (bool global_init_p)
      unless the altivec ABI was set.  This is set by default for 64-bit, but
      not for 32-bit.  */
   if (main_target_opt != NULL && !main_target_opt->x_rs6000_altivec_abi)
-    rs6000_isa_flags &= ~((OPTION_MASK_VSX | OPTION_MASK_ALTIVEC)
-			  & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) &= ~((OPTION_MASK_VSX | OPTION_MASK_ALTIVEC)
+			  & ~GCC_OPTION (rs6000_isa_flags_explicit));
 
   /* Enable Altivec ABI for AIX -maltivec.  */
   if (TARGET_XCOFF && (TARGET_ALTIVEC || TARGET_VSX))
@@ -3507,7 +3507,7 @@ rs6000_option_override_internal (bool global_init_p)
       if (main_target_opt != NULL && !main_target_opt->x_rs6000_altivec_abi)
 	error ("target attribute or pragma changes AltiVec ABI");
       else
-	rs6000_altivec_abi = 1;
+	GCC_OPTION (rs6000_altivec_abi) = 1;
     }
 
   /* The AltiVec ABI is the default for PowerPC-64 GNU/Linux.  For
@@ -3522,7 +3522,7 @@ rs6000_option_override_internal (bool global_init_p)
 	      !main_target_opt->x_rs6000_altivec_abi)
 	    error ("target attribute or pragma changes AltiVec ABI");
 	  else
-	    rs6000_altivec_abi = 1;
+	    GCC_OPTION (rs6000_altivec_abi) = 1;
 	}
     }
 
@@ -3536,20 +3536,20 @@ rs6000_option_override_internal (bool global_init_p)
 	error ("target attribute or pragma changes darwin64 ABI");
       else
 	{
-	  rs6000_darwin64_abi = 1;
+	  GCC_OPTION (rs6000_darwin64_abi) = 1;
 	  /* Default to natural alignment, for better performance.  */
-	  rs6000_alignment_flags = MASK_ALIGN_NATURAL;
+	  GCC_OPTION (rs6000_alignment_flags) = MASK_ALIGN_NATURAL;
 	}
     }
 
   /* Place FP constants in the constant pool instead of TOC
      if section anchors enabled.  */
-  if (flag_section_anchors
+  if (GCC_OPTION (flag_section_anchors)
       && !global_options_set.x_TARGET_NO_FP_IN_TOC)
-    TARGET_NO_FP_IN_TOC = 1;
+    GCC_OPTION (TARGET_NO_FP_IN_TOC) = 1;
 
   if (TARGET_DEBUG_REG || TARGET_DEBUG_TARGET)
-    rs6000_print_isa_options (stderr, 0, "before subtarget", rs6000_isa_flags);
+    rs6000_print_isa_options (stderr, 0, "before subtarget", GCC_OPTION (rs6000_isa_flags));
 
 #ifdef SUBTARGET_OVERRIDE_OPTIONS
   SUBTARGET_OVERRIDE_OPTIONS;
@@ -3562,7 +3562,7 @@ rs6000_option_override_internal (bool global_init_p)
 #endif
 
   if (TARGET_DEBUG_REG || TARGET_DEBUG_TARGET)
-    rs6000_print_isa_options (stderr, 0, "after subtarget", rs6000_isa_flags);
+    rs6000_print_isa_options (stderr, 0, "after subtarget", GCC_OPTION (rs6000_isa_flags));
 
   /* For the E500 family of cores, reset the single/double FP flags to let us
      check that they remain constant across attributes or pragmas.  Also,
@@ -3572,7 +3572,7 @@ rs6000_option_override_internal (bool global_init_p)
      For other families, clear ISEL in case it was set implicitly.
   */
 
-  switch (rs6000_cpu)
+  switch (GCC_OPTION (rs6000_cpu))
     {
     case PROCESSOR_PPC8540:
     case PROCESSOR_PPC8548:
@@ -3581,27 +3581,27 @@ rs6000_option_override_internal (bool global_init_p)
     case PROCESSOR_PPCE5500:
     case PROCESSOR_PPCE6500:
 
-      rs6000_single_float = TARGET_E500_SINGLE || TARGET_E500_DOUBLE;
-      rs6000_double_float = TARGET_E500_DOUBLE;
+      GCC_OPTION (rs6000_single_float) = TARGET_E500_SINGLE || TARGET_E500_DOUBLE;
+      GCC_OPTION (rs6000_double_float) = TARGET_E500_DOUBLE;
 
-      rs6000_isa_flags &= ~OPTION_MASK_STRING;
+      GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_STRING;
 
       break;
 
     default:
 
-      if (have_cpu && !(rs6000_isa_flags_explicit & OPTION_MASK_ISEL))
-	rs6000_isa_flags &= ~OPTION_MASK_ISEL;
+      if (have_cpu && !(GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_ISEL))
+	GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_ISEL;
 
       break;
     }
 
   if (main_target_opt)
     {
-      if (main_target_opt->x_rs6000_single_float != rs6000_single_float)
+      if (main_target_opt->x_rs6000_single_float != GCC_OPTION (rs6000_single_float))
 	error ("target attribute or pragma changes single precision floating "
 	       "point");
-      if (main_target_opt->x_rs6000_double_float != rs6000_double_float)
+      if (main_target_opt->x_rs6000_double_float != GCC_OPTION (rs6000_double_float))
 	error ("target attribute or pragma changes double precision floating "
 	       "point");
     }
@@ -3609,76 +3609,76 @@ rs6000_option_override_internal (bool global_init_p)
   /* Detect invalid option combinations with E500.  */
   CHECK_E500_OPTIONS;
 
-  rs6000_always_hint = (rs6000_cpu != PROCESSOR_POWER4
-			&& rs6000_cpu != PROCESSOR_POWER5
-			&& rs6000_cpu != PROCESSOR_POWER6
-			&& rs6000_cpu != PROCESSOR_POWER7
-			&& rs6000_cpu != PROCESSOR_POWER8
-			&& rs6000_cpu != PROCESSOR_PPCA2
-			&& rs6000_cpu != PROCESSOR_CELL
-			&& rs6000_cpu != PROCESSOR_PPC476);
-  rs6000_sched_groups = (rs6000_cpu == PROCESSOR_POWER4
-			 || rs6000_cpu == PROCESSOR_POWER5
-			 || rs6000_cpu == PROCESSOR_POWER7
-			 || rs6000_cpu == PROCESSOR_POWER8);
-  rs6000_align_branch_targets = (rs6000_cpu == PROCESSOR_POWER4
-				 || rs6000_cpu == PROCESSOR_POWER5
-				 || rs6000_cpu == PROCESSOR_POWER6
-				 || rs6000_cpu == PROCESSOR_POWER7
-				 || rs6000_cpu == PROCESSOR_POWER8
-				 || rs6000_cpu == PROCESSOR_PPCE500MC
-				 || rs6000_cpu == PROCESSOR_PPCE500MC64
-				 || rs6000_cpu == PROCESSOR_PPCE5500
-				 || rs6000_cpu == PROCESSOR_PPCE6500);
+  GCC_OPTION (rs6000_always_hint) = (GCC_OPTION (rs6000_cpu) != PROCESSOR_POWER4
+			&& GCC_OPTION (rs6000_cpu) != PROCESSOR_POWER5
+			&& GCC_OPTION (rs6000_cpu) != PROCESSOR_POWER6
+			&& GCC_OPTION (rs6000_cpu) != PROCESSOR_POWER7
+			&& GCC_OPTION (rs6000_cpu) != PROCESSOR_POWER8
+			&& GCC_OPTION (rs6000_cpu) != PROCESSOR_PPCA2
+			&& GCC_OPTION (rs6000_cpu) != PROCESSOR_CELL
+			&& GCC_OPTION (rs6000_cpu) != PROCESSOR_PPC476);
+  GCC_OPTION (rs6000_sched_groups) = (GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER4
+			 || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER5
+			 || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER7
+			 || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER8);
+  GCC_OPTION (rs6000_align_branch_targets) = (GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER4
+				 || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER5
+				 || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER6
+				 || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER7
+				 || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER8
+				 || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE500MC
+				 || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE500MC64
+				 || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE5500
+				 || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE6500);
 
   /* Allow debug switches to override the above settings.  These are set to -1
      in rs6000.opt to indicate the user hasn't directly set the switch.  */
-  if (TARGET_ALWAYS_HINT >= 0)
-    rs6000_always_hint = TARGET_ALWAYS_HINT;
+  if (GCC_OPTION (TARGET_ALWAYS_HINT) >= 0)
+    GCC_OPTION (rs6000_always_hint) = GCC_OPTION (TARGET_ALWAYS_HINT);
 
-  if (TARGET_SCHED_GROUPS >= 0)
-    rs6000_sched_groups = TARGET_SCHED_GROUPS;
+  if (GCC_OPTION (TARGET_SCHED_GROUPS) >= 0)
+    GCC_OPTION (rs6000_sched_groups) = GCC_OPTION (TARGET_SCHED_GROUPS);
 
-  if (TARGET_ALIGN_BRANCH_TARGETS >= 0)
-    rs6000_align_branch_targets = TARGET_ALIGN_BRANCH_TARGETS;
+  if (GCC_OPTION (TARGET_ALIGN_BRANCH_TARGETS) >= 0)
+    GCC_OPTION (rs6000_align_branch_targets) = GCC_OPTION (TARGET_ALIGN_BRANCH_TARGETS);
 
-  rs6000_sched_restricted_insns_priority
-    = (rs6000_sched_groups ? 1 : 0);
+  GCC_OPTION (rs6000_sched_restricted_insns_priority)
+    = (GCC_OPTION (rs6000_sched_groups) ? 1 : 0);
 
   /* Handle -msched-costly-dep option.  */
-  rs6000_sched_costly_dep
-    = (rs6000_sched_groups ? true_store_to_load_dep_costly : no_dep_costly);
-
-  if (rs6000_sched_costly_dep_str)
-    {
-      if (! strcmp (rs6000_sched_costly_dep_str, "no"))
-	rs6000_sched_costly_dep = no_dep_costly;
-      else if (! strcmp (rs6000_sched_costly_dep_str, "all"))
-	rs6000_sched_costly_dep = all_deps_costly;
-      else if (! strcmp (rs6000_sched_costly_dep_str, "true_store_to_load"))
-	rs6000_sched_costly_dep = true_store_to_load_dep_costly;
-      else if (! strcmp (rs6000_sched_costly_dep_str, "store_to_load"))
-	rs6000_sched_costly_dep = store_to_load_dep_costly;
+  GCC_OPTION (rs6000_sched_costly_dep)
+    = (GCC_OPTION (rs6000_sched_groups) ? true_store_to_load_dep_costly : no_dep_costly);
+
+  if (GCC_OPTION (rs6000_sched_costly_dep_str))
+    {
+      if (! strcmp (GCC_OPTION (rs6000_sched_costly_dep_str), "no"))
+	GCC_OPTION (rs6000_sched_costly_dep) = no_dep_costly;
+      else if (! strcmp (GCC_OPTION (rs6000_sched_costly_dep_str), "all"))
+	GCC_OPTION (rs6000_sched_costly_dep) = all_deps_costly;
+      else if (! strcmp (GCC_OPTION (rs6000_sched_costly_dep_str), "true_store_to_load"))
+	GCC_OPTION (rs6000_sched_costly_dep) = true_store_to_load_dep_costly;
+      else if (! strcmp (GCC_OPTION (rs6000_sched_costly_dep_str), "store_to_load"))
+	GCC_OPTION (rs6000_sched_costly_dep) = store_to_load_dep_costly;
       else
-	rs6000_sched_costly_dep = ((enum rs6000_dependence_cost)
-				   atoi (rs6000_sched_costly_dep_str));
+	GCC_OPTION (rs6000_sched_costly_dep) = ((enum rs6000_dependence_cost)
+				   atoi (GCC_OPTION (rs6000_sched_costly_dep_str)));
     }
 
   /* Handle -minsert-sched-nops option.  */
-  rs6000_sched_insert_nops
-    = (rs6000_sched_groups ? sched_finish_regroup_exact : sched_finish_none);
+  GCC_OPTION (rs6000_sched_insert_nops)
+    = (GCC_OPTION (rs6000_sched_groups) ? sched_finish_regroup_exact : sched_finish_none);
 
-  if (rs6000_sched_insert_nops_str)
+  if (GCC_OPTION (rs6000_sched_insert_nops_str))
     {
-      if (! strcmp (rs6000_sched_insert_nops_str, "no"))
-	rs6000_sched_insert_nops = sched_finish_none;
-      else if (! strcmp (rs6000_sched_insert_nops_str, "pad"))
-	rs6000_sched_insert_nops = sched_finish_pad_groups;
-      else if (! strcmp (rs6000_sched_insert_nops_str, "regroup_exact"))
-	rs6000_sched_insert_nops = sched_finish_regroup_exact;
+      if (! strcmp (GCC_OPTION (rs6000_sched_insert_nops_str), "no"))
+	GCC_OPTION (rs6000_sched_insert_nops) = sched_finish_none;
+      else if (! strcmp (GCC_OPTION (rs6000_sched_insert_nops_str), "pad"))
+	GCC_OPTION (rs6000_sched_insert_nops) = sched_finish_pad_groups;
+      else if (! strcmp (GCC_OPTION (rs6000_sched_insert_nops_str), "regroup_exact"))
+	GCC_OPTION (rs6000_sched_insert_nops) = sched_finish_regroup_exact;
       else
-	rs6000_sched_insert_nops = ((enum rs6000_nop_insertion)
-				    atoi (rs6000_sched_insert_nops_str));
+	GCC_OPTION (rs6000_sched_insert_nops) = ((enum rs6000_nop_insertion)
+				    atoi (GCC_OPTION (rs6000_sched_insert_nops_str)));
     }
 
   if (global_init_p)
@@ -3694,12 +3694,12 @@ rs6000_option_override_internal (bool global_init_p)
 	 If -maix-struct-return or -msvr4-struct-return was explicitly
 	 used, don't override with the ABI default.  */
       if (!global_options_set.x_aix_struct_return)
-	aix_struct_return = (DEFAULT_ABI != ABI_V4 || DRAFT_V4_STRUCT_RET);
+	GCC_OPTION (aix_struct_return) = (DEFAULT_ABI != ABI_V4 || DRAFT_V4_STRUCT_RET);
 
 #if 0
       /* IBM XL compiler defaults to unsigned bitfields.  */
-      if (TARGET_XL_COMPAT)
-	flag_signed_bitfields = 0;
+      if (GCC_OPTION (TARGET_XL_COMPAT))
+	GCC_OPTION (flag_signed_bitfields) = 0;
 #endif
 
       if (TARGET_LONG_DOUBLE_128 && !TARGET_IEEEQUAD)
@@ -3718,30 +3718,30 @@ rs6000_option_override_internal (bool global_init_p)
 
 
       /* Set branch target alignment, if not optimizing for size.  */
-      if (!optimize_size)
+      if (!GCC_OPTION (optimize_size))
 	{
 	  /* Cell wants to be aligned 8byte for dual issue.  Titan wants to be
 	     aligned 8byte to avoid misprediction by the branch predictor.  */
-	  if (rs6000_cpu == PROCESSOR_TITAN
-	      || rs6000_cpu == PROCESSOR_CELL)
+	  if (GCC_OPTION (rs6000_cpu) == PROCESSOR_TITAN
+	      || GCC_OPTION (rs6000_cpu) == PROCESSOR_CELL)
 	    {
-	      if (align_functions <= 0)
-		align_functions = 8;
-	      if (align_jumps <= 0)
-		align_jumps = 8;
-	      if (align_loops <= 0)
-		align_loops = 8;
+	      if (GCC_OPTION (align_functions) <= 0)
+		GCC_OPTION (align_functions) = 8;
+	      if (GCC_OPTION (align_jumps) <= 0)
+		GCC_OPTION (align_jumps) = 8;
+	      if (GCC_OPTION (align_loops) <= 0)
+		GCC_OPTION (align_loops) = 8;
 	    }
-	  if (rs6000_align_branch_targets)
+	  if (GCC_OPTION (rs6000_align_branch_targets))
 	    {
-	      if (align_functions <= 0)
-		align_functions = 16;
-	      if (align_jumps <= 0)
-		align_jumps = 16;
-	      if (align_loops <= 0)
+	      if (GCC_OPTION (align_functions) <= 0)
+		GCC_OPTION (align_functions) = 16;
+	      if (GCC_OPTION (align_jumps) <= 0)
+		GCC_OPTION (align_jumps) = 16;
+	      if (GCC_OPTION (align_loops) <= 0)
 		{
-		  can_override_loop_align = 1;
-		  align_loops = 16;
+		  GCC_OPTION (can_override_loop_align) = 1;
+		  GCC_OPTION (align_loops) = 16;
 		}
 	    }
 	  if (align_jumps_max_skip <= 0)
@@ -3760,10 +3760,10 @@ rs6000_option_override_internal (bool global_init_p)
     }
 
   /* Initialize rs6000_cost with the appropriate target costs.  */
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     rs6000_cost = TARGET_POWERPC64 ? &size64_cost : &size32_cost;
   else
-    switch (rs6000_cpu)
+    switch (GCC_OPTION (rs6000_cpu))
       {
       case PROCESSOR_RS64A:
 	rs6000_cost = &rs64a_cost;
@@ -3917,23 +3917,23 @@ rs6000_option_override_internal (bool global_init_p)
      If TARGET_HARD_FLOAT is set, but neither single or double is set, 
      then set both flags. */
   if (TARGET_HARD_FLOAT && TARGET_FPRS 
-      && rs6000_single_float == 0 && rs6000_double_float == 0)
-    rs6000_single_float = rs6000_double_float = 1;
+      && GCC_OPTION (rs6000_single_float) == 0 && GCC_OPTION (rs6000_double_float) == 0)
+    GCC_OPTION (rs6000_single_float) = GCC_OPTION (rs6000_double_float) = 1;
 
   /* If not explicitly specified via option, decide whether to generate indexed
      load/store instructions.  */
-  if (TARGET_AVOID_XFORM == -1)
+  if (GCC_OPTION (TARGET_AVOID_XFORM) == -1)
     /* Avoid indexed addressing when targeting Power6 in order to avoid the
      DERAT mispredict penalty.  However the LVE and STVE altivec instructions
      need indexed accesses and the type used is the scalar type of the element
      being loaded or stored.  */
-    TARGET_AVOID_XFORM = (rs6000_cpu == PROCESSOR_POWER6 && TARGET_CMPB
+    GCC_OPTION (TARGET_AVOID_XFORM) = (GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER6 && TARGET_CMPB
 			  && !TARGET_ALTIVEC);
 
   /* Set the -mrecip options.  */
-  if (rs6000_recip_name)
+  if (GCC_OPTION (rs6000_recip_name))
     {
-      char *p = ASTRDUP (rs6000_recip_name);
+      char *p = ASTRDUP (GCC_OPTION (rs6000_recip_name));
       char *q;
       unsigned int mask, i;
       bool invert;
@@ -3971,9 +3971,9 @@ rs6000_option_override_internal (bool global_init_p)
 	    }
 
 	  if (invert)
-	    rs6000_recip_control &= ~mask;
+	    GCC_OPTION (rs6000_recip_control) &= ~mask;
 	  else
-	    rs6000_recip_control |= mask;
+	    GCC_OPTION (rs6000_recip_control) |= mask;
 	}
     }
 
@@ -3981,13 +3981,13 @@ rs6000_option_override_internal (bool global_init_p)
      builtins were used.  In the past we used target_flags, but we've run out
      of bits, and some options like SPE and PAIRED are no longer in
      target_flags.  */
-  rs6000_builtin_mask = rs6000_builtin_mask_calculate ();
+  GCC_OPTION (rs6000_builtin_mask) = rs6000_builtin_mask_calculate ();
   if (TARGET_DEBUG_BUILTIN || TARGET_DEBUG_TARGET)
     {
       fprintf (stderr,
 	       "new builtin mask = " HOST_WIDE_INT_PRINT_HEX ", ",
-	       rs6000_builtin_mask);
-      rs6000_print_builtin_options (stderr, 0, NULL, rs6000_builtin_mask);
+	       GCC_OPTION (rs6000_builtin_mask));
+      rs6000_print_builtin_options (stderr, 0, NULL, GCC_OPTION (rs6000_builtin_mask));
     }
 
   /* Initialize all of the registers.  */
@@ -4001,7 +4001,7 @@ rs6000_option_override_internal (bool global_init_p)
   /* If not explicitly specified via option, decide whether to generate the
      extra blr's required to preserve the link stack on some cpus (eg, 476).  */
   if (TARGET_LINK_STACK == -1)
-    SET_TARGET_LINK_STACK (rs6000_cpu == PROCESSOR_PPC476 && flag_pic);
+    SET_TARGET_LINK_STACK (GCC_OPTION (rs6000_cpu) == PROCESSOR_PPC476 && GCC_OPTION (flag_pic));
 
   return ret;
 }
@@ -4034,7 +4034,7 @@ rs6000_loop_align (rtx label)
   int ninsns;
 
   /* Don't override loop alignment if -falign-loops was specified. */
-  if (!can_override_loop_align)
+  if (!GCC_OPTION (can_override_loop_align))
     return align_loops_log;
 
   bb = BLOCK_FOR_INSN (label);
@@ -4042,11 +4042,11 @@ rs6000_loop_align (rtx label)
 
   /* Align small loops to 32 bytes to fit in an icache sector, otherwise return default. */
   if (ninsns > 4 && ninsns <= 8
-      && (rs6000_cpu == PROCESSOR_POWER4
-	  || rs6000_cpu == PROCESSOR_POWER5
-	  || rs6000_cpu == PROCESSOR_POWER6
-	  || rs6000_cpu == PROCESSOR_POWER7
-	  || rs6000_cpu == PROCESSOR_POWER8))
+      && (GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER4
+	  || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER5
+	  || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER6
+	  || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER7
+	  || GCC_OPTION (rs6000_cpu) == PROCESSOR_POWER8))
     return 5;
   else
     return align_loops_log;
@@ -4071,10 +4071,10 @@ rs6000_vector_alignment_reachable (const_tree type ATTRIBUTE_UNUSED, bool is_pac
 
   if (TARGET_32BIT)
     {
-      if (rs6000_alignment_flags == MASK_ALIGN_NATURAL)
+      if (GCC_OPTION (rs6000_alignment_flags) == MASK_ALIGN_NATURAL)
         return true;
 
-      if (rs6000_alignment_flags ==  MASK_ALIGN_POWER)
+      if (GCC_OPTION (rs6000_alignment_flags) ==  MASK_ALIGN_POWER)
         return true;
 
       return false;
@@ -4162,7 +4162,7 @@ rs6000_builtin_vectorization_cost (enum vect_cost_for_stmt type_of_cost,
         return 3;
 
       case unaligned_load:
-        if (TARGET_VSX && TARGET_ALLOW_MOVMISALIGN)
+        if (TARGET_VSX && GCC_OPTION (TARGET_ALLOW_MOVMISALIGN))
           {
             elements = TYPE_VECTOR_SUBPARTS (vectype);
             if (elements == 2)
@@ -4197,7 +4197,7 @@ rs6000_builtin_vectorization_cost (enum vect_cost_for_stmt type_of_cost,
         return 2;
 
       case unaligned_store:
-        if (TARGET_VSX && TARGET_ALLOW_MOVMISALIGN)
+        if (TARGET_VSX && GCC_OPTION (TARGET_ALLOW_MOVMISALIGN))
           {
             elements = TYPE_VECTOR_SUBPARTS (vectype);
             if (elements == 2)
@@ -4370,7 +4370,7 @@ rs6000_add_stmt_cost (void *data, int count, enum vect_cost_for_stmt kind,
   rs6000_cost_data *cost_data = (rs6000_cost_data*) data;
   unsigned retval = 0;
 
-  if (flag_vect_cost_model)
+  if (GCC_OPTION (flag_vect_cost_model))
     {
       tree vectype = stmt_info ? stmt_vectype (stmt_info) : NULL_TREE;
       int stmt_cost = rs6000_builtin_vectorization_cost (kind, vectype,
@@ -4430,7 +4430,7 @@ rs6000_builtin_vectorized_libmass (tree fndecl, tree type_out, tree type_in)
      parts of IEEE with the required precision such as denormals.  Only support
      it if we have VSX to use the simd d2 or f4 functions.
      XXX: Add variable length support.  */
-  if (!flag_unsafe_math_optimizations || !TARGET_VSX)
+  if (!GCC_OPTION (flag_unsafe_math_optimizations) || !TARGET_VSX)
     return NULL_TREE;
 
   el_mode = TYPE_MODE (TREE_TYPE (type_out));
@@ -4574,7 +4574,7 @@ rs6000_builtin_vectorized_function (tree fndecl, tree type_out,
 
   if (TREE_CODE (type_out) != VECTOR_TYPE
       || TREE_CODE (type_in) != VECTOR_TYPE
-      || !TARGET_VECTORIZE_BUILTINS)
+      || !GCC_OPTION (TARGET_VECTORIZE_BUILTINS))
     return NULL_TREE;
 
   out_mode = TYPE_MODE (TREE_TYPE (type_out));
@@ -4709,28 +4709,28 @@ rs6000_builtin_vectorized_function (tree fndecl, tree type_out,
 	  break;
 	case BUILT_IN_NEARBYINT:
 	  if (VECTOR_UNIT_VSX_P (V2DFmode)
-	      && flag_unsafe_math_optimizations
+	      && GCC_OPTION (flag_unsafe_math_optimizations)
 	      && out_mode == DFmode && out_n == 2
 	      && in_mode == DFmode && in_n == 2)
 	    return rs6000_builtin_decls[VSX_BUILTIN_XVRDPI];
 	  break;
 	case BUILT_IN_NEARBYINTF:
 	  if (VECTOR_UNIT_VSX_P (V4SFmode)
-	      && flag_unsafe_math_optimizations
+	      && GCC_OPTION (flag_unsafe_math_optimizations)
 	      && out_mode == SFmode && out_n == 4
 	      && in_mode == SFmode && in_n == 4)
 	    return rs6000_builtin_decls[VSX_BUILTIN_XVRSPI];
 	  break;
 	case BUILT_IN_RINT:
 	  if (VECTOR_UNIT_VSX_P (V2DFmode)
-	      && !flag_trapping_math
+	      && !GCC_OPTION (flag_trapping_math)
 	      && out_mode == DFmode && out_n == 2
 	      && in_mode == DFmode && in_n == 2)
 	    return rs6000_builtin_decls[VSX_BUILTIN_XVRDPIC];
 	  break;
 	case BUILT_IN_RINTF:
 	  if (VECTOR_UNIT_VSX_P (V4SFmode)
-	      && !flag_trapping_math
+	      && !GCC_OPTION (flag_trapping_math)
 	      && out_mode == SFmode && out_n == 4
 	      && in_mode == SFmode && in_n == 4)
 	    return rs6000_builtin_decls[VSX_BUILTIN_XVRSPIC];
@@ -4798,7 +4798,7 @@ rs6000_file_start (void)
 
   default_file_start ();
 
-  if (flag_verbose_asm)
+  if (GCC_OPTION (flag_verbose_asm))
     {
       sprintf (buffer, "\n%s rs6000/powerpc options:", ASM_COMMENT_START);
 
@@ -4811,14 +4811,14 @@ rs6000_file_start (void)
       if (global_options_set.x_rs6000_cpu_index)
 	{
 	  fprintf (file, "%s -mcpu=%s", start,
-		   processor_target_table[rs6000_cpu_index].name);
+		   processor_target_table[GCC_OPTION (rs6000_cpu_index)].name);
 	  start = "";
 	}
 
       if (global_options_set.x_rs6000_tune_index)
 	{
 	  fprintf (file, "%s -mtune=%s", start,
-		   processor_target_table[rs6000_tune_index].name);
+		   processor_target_table[GCC_OPTION (rs6000_tune_index)].name);
 	  start = "";
 	}
 
@@ -4829,7 +4829,7 @@ rs6000_file_start (void)
 	}
 
 #ifdef USING_ELFOS_H
-      switch (rs6000_sdata)
+      switch (GCC_OPTION (rs6000_sdata))
 	{
 	case SDATA_NONE: fprintf (file, "%s -msdata=none", start); start = ""; break;
 	case SDATA_DATA: fprintf (file, "%s -msdata=data", start); start = ""; break;
@@ -4837,10 +4837,10 @@ rs6000_file_start (void)
 	case SDATA_EABI: fprintf (file, "%s -msdata=eabi", start); start = ""; break;
 	}
 
-      if (rs6000_sdata && g_switch_value)
+      if (GCC_OPTION (rs6000_sdata) && GCC_OPTION (g_switch_value))
 	{
 	  fprintf (file, "%s -G %d", start,
-		   g_switch_value);
+		   GCC_OPTION (g_switch_value));
 	  start = "";
 	}
 #endif
@@ -4853,7 +4853,7 @@ rs6000_file_start (void)
     fprintf (file, "\t.abiversion 2\n");
 
   if (DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2
-      || (TARGET_ELF && flag_pic == 2))
+      || (TARGET_ELF && GCC_OPTION (flag_pic) == 2))
     {
       switch_to_section (toc_section);
       switch_to_section (text_section);
@@ -5907,7 +5907,7 @@ small_data_operand (rtx op ATTRIBUTE_UNUSED,
 #if TARGET_ELF
   rtx sym_ref;
 
-  if (rs6000_sdata == SDATA_NONE || rs6000_sdata == SDATA_DATA)
+  if (GCC_OPTION (rs6000_sdata) == SDATA_NONE || GCC_OPTION (rs6000_sdata) == SDATA_DATA)
     return 0;
 
   if (DEFAULT_ABI != ABI_V4)
@@ -5937,7 +5937,7 @@ small_data_operand (rtx op ATTRIBUTE_UNUSED,
       /* We have to be careful here, because it is the referenced address
 	 that must be 32k from _SDA_BASE_, not just the symbol.  */
       summand = INTVAL (XEXP (sum, 1));
-      if (summand < 0 || summand > g_switch_value)
+      if (summand < 0 || summand > GCC_OPTION (g_switch_value))
 	return 0;
 
       sym_ref = XEXP (sum, 0);
@@ -6015,7 +6015,7 @@ quad_load_store_p (rtx op0, rtx op1)
   else
     ret = false;
 
-  if (TARGET_DEBUG_ADDR)
+  if (GCC_OPTION (TARGET_DEBUG_ADDR))
     {
       fprintf (stderr, "\n========== quad_load_store, return %s\n",
 	       ret ? "true" : "false");
@@ -6325,7 +6325,7 @@ static bool
 legitimate_small_data_p (enum machine_mode mode, rtx x)
 {
   return (DEFAULT_ABI == ABI_V4
-	  && !flag_pic && !TARGET_TOC
+	  && !GCC_OPTION (flag_pic) && !TARGET_TOC
 	  && (GET_CODE (x) == SYMBOL_REF || GET_CODE (x) == CONST)
 	  && small_data_operand (x, mode));
 }
@@ -6445,7 +6445,7 @@ avoiding_indexed_address_p (enum machine_mode mode)
 {
   /* Avoid indexed addressing for modes that have non-indexed
      load/store instruction forms.  */
-  return (TARGET_AVOID_XFORM && VECTOR_MEM_NONE_P (mode));
+  return (GCC_OPTION (TARGET_AVOID_XFORM) && VECTOR_MEM_NONE_P (mode));
 }
 
 bool
@@ -6457,7 +6457,7 @@ legitimate_indirect_address_p (rtx x, int strict)
 bool
 macho_lo_sum_memory_operand (rtx x, enum machine_mode mode)
 {
-  if (!TARGET_MACHO || !flag_pic
+  if (!TARGET_MACHO || !GCC_OPTION (flag_pic)
       || mode != SImode || GET_CODE (x) != MEM)
     return false;
   x = XEXP (x, 0);
@@ -6491,7 +6491,7 @@ legitimate_lo_sum_address_p (enum machine_mode mode, rtx x, int strict)
     {
       bool large_toc_ok;
 
-      if (DEFAULT_ABI == ABI_V4 && flag_pic)
+      if (DEFAULT_ABI == ABI_V4 && GCC_OPTION (flag_pic))
 	return false;
       /* LRA don't use LEGITIMIZE_RELOAD_ADDRESS as it usually calls
 	 push_reload from reload pass code.  LEGITIMIZE_RELOAD_ADDRESS
@@ -6665,7 +6665,7 @@ rs6000_legitimize_address (rtx x, rtx oldx ATTRIBUTE_UNUSED,
 	    )
 	   && TARGET_32BIT
 	   && TARGET_NO_TOC
-	   && ! flag_pic
+	   && ! GCC_OPTION (flag_pic)
 	   && GET_CODE (x) != CONST_INT
 	   && GET_CODE (x) != CONST_DOUBLE
 	   && CONSTANT_P (x)
@@ -6993,7 +6993,7 @@ rs6000_legitimize_tls_address (rtx addr, enum tls_model model)
     return rs6000_legitimize_tls_address_aix (addr, model);
 
   dest = gen_reg_rtx (Pmode);
-  if (model == TLS_MODEL_LOCAL_EXEC && rs6000_tls_size == 16)
+  if (model == TLS_MODEL_LOCAL_EXEC && GCC_OPTION (rs6000_tls_size) == 16)
     {
       rtx tlsreg;
 
@@ -7009,7 +7009,7 @@ rs6000_legitimize_tls_address (rtx addr, enum tls_model model)
 	}
       emit_insn (insn);
     }
-  else if (model == TLS_MODEL_LOCAL_EXEC && rs6000_tls_size == 32)
+  else if (model == TLS_MODEL_LOCAL_EXEC && GCC_OPTION (rs6000_tls_size) == 32)
     {
       rtx tlsreg, tmp;
 
@@ -7044,13 +7044,13 @@ rs6000_legitimize_tls_address (rtx addr, enum tls_model model)
 	got = gen_rtx_REG (Pmode, 2);
       else
 	{
-	  if (flag_pic == 1)
+	  if (GCC_OPTION (flag_pic) == 1)
 	    got = gen_rtx_REG (Pmode, RS6000_PIC_OFFSET_TABLE_REGNUM);
 	  else
 	    {
 	      rtx gsym = rs6000_got_sym ();
 	      got = gen_reg_rtx (Pmode);
-	      if (flag_pic == 0)
+	      if (GCC_OPTION (flag_pic) == 0)
 		rs6000_emit_move (got, gsym, Pmode);
 	      else
 		{
